package cz.bilysklep.trainings.basicjava.swingexample;

import java.time.LocalDate;
import java.time.Month;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

public class PersonServiceImpl implements PersonService {
    
    private static final List<Person> DEMO_DATA = Arrays.asList(
            new Person("Petr Adámek", Gender.MALE, LocalDate.of(1977,Month.JUNE,16)),
            new Person("Jan Novák", Gender.MALE, LocalDate.of(2010, Month.MARCH, 12)),
            new Person("Jan Petřík", Gender.MALE, LocalDate.of(1990, Month.MARCH, 29)),
            new Person("Aneta Nová", Gender.FEMALE, LocalDate.of(1983, Month.OCTOBER, 20)),
            new Person("Katrin Světlá", Gender.FEMALE, LocalDate.of(2001, Month.JULY, 15))
    );
          
    private List<Person> data = new CopyOnWriteArrayList<>(DEMO_DATA);
    
    public List<Person> findAllPersons() {
        return Collections.unmodifiableList(data);
    }
    
    public void addPerson(Person person) {
        data.add(person);
    }
    
    public void removePerson(Person person) {
        if (!data.remove(person)) {
            throw new IllegalArgumentException("Person not found: " + person);
        }
    }
}
