package cz.bilysklep.trainings.basicjava.swingexample;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;
import javax.swing.table.AbstractTableModel;

public class PersonTableModelWithSwitch extends AbstractTableModel {

    private List<Person> persons = new ArrayList<>();

    @Override
    public int getRowCount() {
        return persons.size();
    }

    @Override
    public int getColumnCount() {
        return 3;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Person person = persons.get(rowIndex);
        switch (columnIndex) {
            case 0:
                return person.getName();
            case 1:
                return person.getGender();
            case 2:
                return person.getBirthDate();
            default:
                throw new IndexOutOfBoundsException("Invalid column index: " + columnIndex);

        }
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        switch (columnIndex) {
            case 0:
                return String.class;
            case 1:
                return Gender.class;
            case 2:
                return LocalDate.class;
            default:
                throw new IndexOutOfBoundsException("Invalid column index: " + columnIndex);

        }
    }

    @Override
    public String getColumnName(int columnIndex) {
        switch (columnIndex) {
            case 0:
                return "Name";
            case 1:
                return "Gender";
            case 2:
                return "Birthdate";
            default:
                throw new IndexOutOfBoundsException("Invalid column index: " + columnIndex);
        }

    }
}
